/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateCreateDataInteractionsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateCreateDataInteractionsInner{}

// CxTemplateCreateDataInteractionsInner struct for CxTemplateCreateDataInteractionsInner
type CxTemplateCreateDataInteractionsInner struct {
	Id *string `json:"id,omitempty"`
	Name *string `json:"name,omitempty"`
	PreviewUrls []CxTemplateCreateDataInteractionsInnerPreviewUrlsInner `json:"preview_urls,omitempty"`
}

// NewCxTemplateCreateDataInteractionsInner instantiates a new CxTemplateCreateDataInteractionsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateCreateDataInteractionsInner() *CxTemplateCreateDataInteractionsInner {
	this := CxTemplateCreateDataInteractionsInner{}
	return &this
}

// NewCxTemplateCreateDataInteractionsInnerWithDefaults instantiates a new CxTemplateCreateDataInteractionsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateCreateDataInteractionsInnerWithDefaults() *CxTemplateCreateDataInteractionsInner {
	this := CxTemplateCreateDataInteractionsInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CxTemplateCreateDataInteractionsInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateCreateDataInteractionsInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CxTemplateCreateDataInteractionsInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CxTemplateCreateDataInteractionsInner) SetId(v string) {
	o.Id = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CxTemplateCreateDataInteractionsInner) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateCreateDataInteractionsInner) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CxTemplateCreateDataInteractionsInner) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *CxTemplateCreateDataInteractionsInner) SetName(v string) {
	o.Name = &v
}

// GetPreviewUrls returns the PreviewUrls field value if set, zero value otherwise.
func (o *CxTemplateCreateDataInteractionsInner) GetPreviewUrls() []CxTemplateCreateDataInteractionsInnerPreviewUrlsInner {
	if o == nil || IsNil(o.PreviewUrls) {
		var ret []CxTemplateCreateDataInteractionsInnerPreviewUrlsInner
		return ret
	}
	return o.PreviewUrls
}

// GetPreviewUrlsOk returns a tuple with the PreviewUrls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateCreateDataInteractionsInner) GetPreviewUrlsOk() ([]CxTemplateCreateDataInteractionsInnerPreviewUrlsInner, bool) {
	if o == nil || IsNil(o.PreviewUrls) {
		return nil, false
	}
	return o.PreviewUrls, true
}

// HasPreviewUrls returns a boolean if a field has been set.
func (o *CxTemplateCreateDataInteractionsInner) HasPreviewUrls() bool {
	if o != nil && !IsNil(o.PreviewUrls) {
		return true
	}

	return false
}

// SetPreviewUrls gets a reference to the given []CxTemplateCreateDataInteractionsInnerPreviewUrlsInner and assigns it to the PreviewUrls field.
func (o *CxTemplateCreateDataInteractionsInner) SetPreviewUrls(v []CxTemplateCreateDataInteractionsInnerPreviewUrlsInner) {
	o.PreviewUrls = v
}

func (o CxTemplateCreateDataInteractionsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateCreateDataInteractionsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.PreviewUrls) {
		toSerialize["preview_urls"] = o.PreviewUrls
	}
	return toSerialize, nil
}

type NullableCxTemplateCreateDataInteractionsInner struct {
	value *CxTemplateCreateDataInteractionsInner
	isSet bool
}

func (v NullableCxTemplateCreateDataInteractionsInner) Get() *CxTemplateCreateDataInteractionsInner {
	return v.value
}

func (v *NullableCxTemplateCreateDataInteractionsInner) Set(val *CxTemplateCreateDataInteractionsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateCreateDataInteractionsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateCreateDataInteractionsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateCreateDataInteractionsInner(val *CxTemplateCreateDataInteractionsInner) *NullableCxTemplateCreateDataInteractionsInner {
	return &NullableCxTemplateCreateDataInteractionsInner{value: val, isSet: true}
}

func (v NullableCxTemplateCreateDataInteractionsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateCreateDataInteractionsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


